using MediatR;
using Modules.Library.Application.Gateways;
using Modules.Library.Domain.Entities.MediaContent.CommonProperties;
using Modules.Library.Domain.Entities.MediaContent.Items.Anime;

namespace Modules.Library.Application.Commands.Anime.Episode.Properties.Name;

public class EditNameCommand : IRequest<Unit>
{
    public Guid TitleId { get; set; }
    public Guid SeasonId { get; set; }
    public Guid EpisodeId { get; set; }
    public CommonModels.NameType NameType { get; set; }
    public Guid LanguageId { get; set; }
    public string Value { get; set; } = default!;
    public string? NewValue { get; set; }
    public Guid? NewLanguageId { get; set; }
}

public class EditNameCommandHandler(IAnimeTitleGateway titleGateway) : IRequestHandler<EditNameCommand, Unit>
{
    public async Task<Unit> Handle(EditNameCommand request, CancellationToken cancellationToken)
    {
        if (!request.NewLanguageId.HasValue && string.IsNullOrWhiteSpace(request.NewValue))
        {
            throw new ArgumentNullException($"{nameof(EditNameCommand.NewLanguageId)}, {nameof(EditNameCommand.NewValue)}");
        }
        var title = await titleGateway.GetById(request.TitleId);
        var season = title.Items.OfType<AnimeSeason>().FirstOrDefault(q => q.Id == request.SeasonId) ??
            throw new Exception("Season not found");
        var episode = season.Episodes.FirstOrDefault(q => q.Id == request.EpisodeId) ??
            throw new Exception("Episode not found");
        episode.CommonProperties.SetNameValue(new NameItem((NameType)request.NameType, request.LanguageId, request.Value), request.NewLanguageId, request.NewValue);
        await titleGateway.Update(title);
        return Unit.Value;
    }
}